#include "parti.h"

void 
PARTI_gather(sched, data, target, size)
SCHED *sched;			/* schedule */
char  *data,*target;		/* data arrays */
int   size;			/* size of each element */
{
  int  count,i,j;
  char **blist,*buffer;
  char *ptr;
  int    *ibuf, *idata;		/* pointers for integer */
  double *dbuf, *ddata;		/* pointers for double */

#ifdef DEBUG
  trace_enter("new_gather");
#endif

  blist = wbuffer->blist;
  buffer = (char *) malloc(size*sched->ndata);
  count = 0;
  for(i=0;i<PARTI_numnodes;i++){
    blist[i] = &buffer[count];
    count += size * sched->sr->fetch_n[i];
  }

  new_execute_gather(sched->sr, blist, target, size);

/*
  for(i=0, ptr=buffer; i<sched->ndata; i++, ptr+=size){
    bytecopy(&data[size*sched->perm[i]], ptr, size);
  }
*/
  switch(size) {
  case sizeof(int):
    ibuf  = (int *) buffer;
    idata = (int *) data;
    for(i=0;i<sched->ndata;i++)
      idata[sched->perm[i]] = ibuf[i];
    break;
  case sizeof(double):
    dbuf  = (double *) buffer;
    ddata = (double *) data;
    for(i=0;i<sched->ndata;i++)
      ddata[sched->perm[i]] = dbuf[i];
    break;
  case sizeof(char):
    for(i=0;i<sched->ndata;i++)
      data[sched->perm[i]] = buffer[i];
    break;
  default:
    for(i=0, ptr=buffer; i<sched->ndata; i++, ptr+=size)
      bytecopy(&data[size*sched->perm[i]], ptr, size);
    break;
  }

  free(buffer);

#ifdef DEBUG
  trace_exit();
#endif
}

/*
 *  wrapper for the gather function
 */

extern SCHED *get_sched_ptr();

void 
parti_gather_ (sched, data, target, size)
int   *sched;			/* schedule */
char  *data,*target;		/* data arrays */
int   *size;			/* size of each element */
{
  PARTI_gather((SCHED *)get_sched_ptr(*sched), data, target, *size);
}
